//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  Gainsboro
#property indicator_color4  Gainsboro
#property indicator_color5  DeepSkyBlue
#property indicator_color6  PaleVioletRed
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  2
#property indicator_width6  2
#property indicator_minimum -50
#property indicator_maximum  50

//
//
//
//
//

extern string  TimeFrame   = "Current time frame";
extern int     StochasticK  = 100;
extern int     Slowing      = 1;
extern string  FirstSymbol  = "";
extern string  SecondSymbol = "GBPUSD";
extern double  UpLevel      =  26.4;
extern double  DownLevel    = -26.4;
extern bool    Interpolate  = true;

double buffer1[];
double buffer1u[];
double buffer1d[];
double buffer2[];
double buffer2u[];
double buffer2d[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   if (FirstSymbol == "" ) FirstSymbol = Symbol();
      SetIndexBuffer(0,buffer1u); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,buffer1d); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,buffer2u); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,buffer2d); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,buffer1);
      SetIndexBuffer(5,buffer2);

      //
      //
      //
      //
      //
      
         SetLevelValue(0,UpLevel);
         SetLevelValue(1,DownLevel);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,y,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0] = limit; return(0); }
           if (FirstSymbol  != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(FirstSymbol ,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
           if (SecondSymbol != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(SecondSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      y = iBarShift(FirstSymbol ,timeFrame,Time[i]); buffer1[i] = iStochastic(FirstSymbol ,timeFrame,StochasticK,1,Slowing,0,0,0,y)-50;
      y = iBarShift(SecondSymbol,timeFrame,Time[i]); buffer2[i] = iStochastic(SecondSymbol,timeFrame,StochasticK,1,Slowing,0,0,0,y)-50;
   
         //
         //
         //
         //
         //
         
            buffer1u[i] = EMPTY_VALUE;
            buffer1d[i] = EMPTY_VALUE;
            buffer2u[i] = EMPTY_VALUE;
            buffer2d[i] = EMPTY_VALUE;
               double up = 0;
               double dn = 0;
                  if (buffer1[i]>UpLevel)   up++;
                  if (buffer1[i]<DownLevel) dn++;
                  if (buffer2[i]>UpLevel)   up++;
                  if (buffer2[i]<DownLevel) dn++;
                  if (up==2) buffer1u[i] = MathMax(buffer1[i],buffer2[i]);
                  if (dn==2) buffer1d[i] = MathMin(buffer1[i],buffer2[i]);
                  if (up==1) buffer2u[i] = MathMax(buffer1[i],buffer2[i]);
                  if (dn==1) buffer2d[i] = MathMin(buffer1[i],buffer2[i]);
            
         //
         //
         //
         //
         //
         
      if (timeFrame <= Period() || !Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

      //
      //
      //
      //
      //
      
      datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         for(int k = 1; k < n; k++)
         {
            buffer1[i+k] = buffer1[i] +(buffer1[i+n]-buffer1[i])*k/n;
            buffer2[i+k] = buffer2[i] +(buffer2[i+n]-buffer2[i])*k/n;
               if (buffer1u[i+k]!=EMPTY_VALUE) buffer1u[i+k]= MathMax(buffer1[i+k],buffer2[i+k]);
               if (buffer2u[i+k]!=EMPTY_VALUE) buffer2u[i+k]= MathMax(buffer1[i+k],buffer2[i+k]);
               if (buffer1d[i+k]!=EMPTY_VALUE) buffer1d[i+k]= MathMin(buffer1[i+k],buffer2[i+k]);
               if (buffer2d[i+k]!=EMPTY_VALUE) buffer2d[i+k]= MathMin(buffer1[i+k],buffer2[i+k]);
         }               
   }
   IndicatorShortName(timeFrameToString(timeFrame)+" Stochastic ("+StochasticK+","+Slowing+")   "+FirstSymbol+","+SecondSymbol+" - Diff: "+DoubleToStr(MathAbs(buffer1[0]-buffer2[0]),0)+"%    ");
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

